/usr/lib/php/php-maintscript-helper is in php-common 1:49.
This file is owned by root:root, with mode 0o644.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 | #!/bin/sh
#
# php-maintscript-helper - PHP helper function for maintainer scripts
#
# Copyright (C) 2012 Arno Töll <debian@toell.net>
# 2013 Ondřej Surý <ondrej@sury.org>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
# VARIABLES
#
# global environment variables used by php-maintscript-helper:
# * PHP_MAINTSCRIPT_DEBUG:
# set this to any non-zero value to get debug output
# * PHP_MAINTSCRIPT_HELPER_QUIET:
# set this to any non-zero value to omit any output
# * EXPORT_PHP_MAINTSCRIPT_HELPER:
# will be defined by php-maintscript-helper
# to avoid inclusion loops. Do not set this
# variable manually
# * PHP_NEED_ACTION:
# will be defined if a function call wants to
# override the behavior of php_needs_action.
# Do not rely on this variable. It is considered
# an implementation detail.
# * PHP_MAINTSCRIPT_NAME
# * PHP_MAINTSCRIPT_PACKAGE
# * PHP_MAINTSCRIPT_METHOD
# * PHP_MAINTSCRIPT_ARGUMENT
# these variables contain information about the
# maintainer script which is calling the
# maintscript-helper. It contains arguments which
# dpkg supplies to maintainer scripts and similar
# information. These variables are an
# implementation detail and not to be changed.
#
# You might want to set them manually only if you
# are calling php-maintscript-helper from
# some place which does not preserve the original
# script arguments for example when calling from
# a subfunction instead of the main function in
# your maintainer script
#
# INITIALIZATION
#
if [ -n "${EXPORT_PHP_MAINTSCRIPT_HELPER:-}" ] ; then
return
else
EXPORT_PHP_MAINTSCRIPT_HELPER=1
if [ -n "${PHP_MAINTSCRIPT_DEBUG:-}" ] ; then
set -x
fi
if [ -z "$1" ] ; then
echo "You must invoke php-maintscript-helper with an unmodified environment when sourcing it" >&2
return 1
fi
PHP_MAINTSCRIPT_NAME="$DPKG_MAINTSCRIPT_NAME"
[ "$PHP_MAINTSCRIPT_NAME" ] || PHP_MAINTSCRIPT_NAME="${0##*.}"
case "$PHP_MAINTSCRIPT_NAME" in
preinst|prerm|postrm|postinst)
# yay - recognized script
;;
*)
echo "php-maintscript-helper invoked from an unrecognized maintainer script: exiting" >&2
return 1
;;
esac
PHP_MAINTSCRIPT_PACKAGE="$DPKG_MAINTSCRIPT_PACKAGE"
if [ -z "$PHP_MAINTSCRIPT_PACKAGE" ]; then
PHP_MAINTSCRIPT_PACKAGE="${0##*/}"
PHP_MAINTSCRIPT_PACKAGE="${PHP_MAINTSCRIPT_PACKAGE%.*}"
fi
if [ -z "$PHP_MAINTSCRIPT_METHOD" ] ; then
PHP_MAINTSCRIPT_METHOD="$1"
fi
case "$PHP_MAINTSCRIPT_METHOD" in
install|upgrade|abort-upgrade|configure|abort-remove|abort-remove|abort-deconfigure|remove|failed-upgrade|purge|disappear|abort-install)
# yay - recognized script
;;
*)
echo "php-maintscript-helper invoked from a modified environment. Please hint required arguments manually" >&2
return 1
;;
esac
if [ -z "$PHP_MAINTSCRIPT_ARGUMENT" ] ; then
PHP_MAINTSCRIPT_ARGUMENT="${2:-}"
fi
fi
#
# FUNCTIONS
#
#
# Function php_msg
# print out a warning to both, the syslog and a local standard output.
# This function should generally be used to display messages related to
# the web server in maintainer scripts.
# Parameters:
# priority
# The message priority. Recognized values are the same as defined
# by syslog(3), thus: one among debug, info, notice, warning,
# err, crit, alert, emerg.
# If no known priority is recognized, the priority is set to
# "warning".
# message
# The message as a string. It is printed out verbatim.
# Behavior:
# No message is displayed if PHP_MAINTSCRIPT_HELPER_QUIET is defined
# Returns:
# this function always returns 0
# Since: 5.5.0+dfsg-7
php_msg()
{
local PRIORITY="$1"
local MSG="$2"
case "$PRIORITY" in
debug|info|notice|warning|err|crit|alert|emerg)
;;
*)
PRIORITY="warning"
;;
esac
[ -z "$PHP_MAINTSCRIPT_HELPER_QUIET" ] && ( [ -n "${PHP_MAINTSCRIPT_DEBUG:-}" ] || [ "$PRIORITY" != "debug" ] ) && echo "$MSG" >&2
[ -x /usr/bin/logger ] || return 0
local LOGGER="/usr/bin/logger -p daemon.$PRIORITY -t $PHP_MAINTSCRIPT_PACKAGE "
$LOGGER "$MSG" || return 0
}
#
# Function php_invoke
# invokes an PHP configuration helper to enable or disable a
# particular piece of configuration, a site or a module. It carefully
# checks whether the supplied configuration snippet exists and reloads the
# web server if the site administrator desires that by call dpkg trigger
# /etc/php/VERSION/SAPI/conf.d which is defined for apache2, apache2filter and fpm.
#
# Parameters:
# command - The command to invoke. Recognized commands are "enconf",
# "enmod", "ensite", "disconf", "dismod", "dissite"
#
# sapi - Either the specific SAPI (apache2, apache2filter, fpm,
# cgi, cli, embed, phpdbg) or ALL
#
# arguments
# - A single argument (e.g. a module) which shall be
# enabled or disabled respectively.
#
# Returns
# 0 if the changes could be activated
# 1 otherwise
# Since: 5.5.0+dsfg-7
php_invoke()
{
local CMD=$1
local VERSION=$2
local SAPI=$3
local MOD=$4
local check_switch=""
local invoke_string=""
local rcd_action=""
local rcd_scripts=""
local sapi_list=""
[ -x "/usr/sbin/php$CMD" ] || return 1
[ -x "/usr/sbin/phpquery" ] || return 1
case "$VERSION" in
ALL)
version_list=$(phpquery -V)
;;
*)
version_list="$VERSION"
# FIXME - check if the version is supported
;;
esac
for version in $version_list; do
case "$SAPI" in
apache2|apache2filter|fpm|cli|cgi|embed|phpdbg)
sapi_list="$SAPI"
;;
ALL)
sapi_list=$(phpquery -S -v $version)
case "$CMD" in
enmod|dismod)
php$CMD -q -v "$version" -m -r "$MOD" || return 1
;;
*)
return 1
;;
esac
;;
*)
return 1
;;
esac
for sapi in $sapi_list; do
case "$CMD" in
enmod)
local phpquery_ret=0
phpquery -v "$version" -s "$sapi" -m "$MOD" > /dev/null 2>&1 || phpquery_ret=$?
if [ "$phpquery_ret" -eq 0 ] ; then
# configuration is already enabled
php$CMD -m -v "$version" -s "$sapi" -q "$MOD" > /dev/null 2>&1 || return 1
php_msg "debug" "php_invoke $MOD: already enabled for PHP $version $sapi sapi"
PHP_NEED_ACTION=1
elif [ "$phpquery_ret" -eq 32 ] ; then
# the maintainer disabled the module
php_msg "info" "php_invoke $MOD: no action - module was disabled by maintainer for PHP $version $sapi sapi"
return 0
else
# coming here either means:
# a) we have no clue about the module (e.g. for upgrades prior to maintscript-helper
# b) it's a fresh install
PHP_NEED_ACTION=1
php$CMD -m -v "$version" -s "$sapi" -q "$MOD" > /dev/null 2>&1 || return 1
php_msg "info" "php_invoke: Enable module $MOD for $sapi sapi"
fi
;;
dismod)
local phpquery_ret=0
phpquery -v "$version" -s "$sapi" -m "$MOD" > /dev/null 2>&1 || phpquery_ret=$?
if [ "$phpquery_ret" -eq 0 ] ; then
if [ "$PHP_MAINTSCRIPT_NAME" = 'postrm' ] && [ "$PHP_MAINTSCRIPT_METHOD" = "purge" ] ; then
php$CMD -p -f -v "$version" -s "$sapi" -q "$MOD" || return 1
php_msg "debug" "php_invoke $PHP_MAINTSCRIPT_NAME: Purging module $MOD for PHP $version $sapi sapi"
PHP_NEED_ACTION=1
elif [ "$PHP_MAINTSCRIPT_NAME" = 'postrm' ] || [ "$PHP_MAINTSCRIPT_NAME" = 'prerm' ] ; then
if [ "$PHP_MAINTSCRIPT_METHOD" = "remove" ] ; then
php$CMD -m -f -v "$version" -s "$sapi" -q "$MOD" || return 1
php_msg "info" "php_invoke $PHP_MAINTSCRIPT_NAME: Disabled module $MOD for PHP $version $sapi sapi"
PHP_NEED_ACTION=1
fi
else
php_msg "error" "php_invoke: module $MOD not supported in $PHP_MAINTSCRIPT_NAME for PHP $version $sapi sapi"
return 1
fi
elif [ "$phpquery_ret" -eq 32 ] || [ "$phpquery_ret" -eq 33 ] ; then
if [ "$PHP_MAINTSCRIPT_NAME" = 'postrm' ] && [ "$PHP_MAINTSCRIPT_METHOD" = "purge" ] ; then
php_msg "debug" "php_invoke $PHP_MAINTSCRIPT_NAME: Purging state for $MOD for PHP $version $sapi sapi"
# this will return RC=1
( php$CMD -p -f -v "$version" -s "$sapi" -q "$MOD" > /dev/null 2>&1 )
else
php_msg "debug" "php_invoke $MOD $PHP_MAINTSCRIPT_NAME: No action required for PHP $version $sapi sapi"
fi
else
php_msg "debug" "php_invoke $MOD $PHP_MAINTSCRIPT_NAME: No action required for PHP $version $sapi sapi"
fi
;;
*)
return 1
;;
esac
if [ -n "${PHP_NEED_ACTION:-}" -a -n "$rcd_action" ]; then
dpkg-trigger /etc/php/$version/$sapi/conf.d
fi
done
done
}
# vim: syntax=sh sw=8 sts=8 sr noet
|